/* 
   IM Caf - A Java Based Instant Messaging System
   Author: Bruno Freitas - 08/2004
   Contact: bootsector@ig.com.br
 
   Copyright (c) 2004 Bruno Freitas

   Permission is hereby granted, free of charge, to any person obtaining a copy of
   this software and associated documentation files (the "Software"), to deal in 
   the Software without restriction, including without limitation the rights to 
   use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies 
   of the Software, and to permit persons to whom the Software is furnished to do 
   so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in all 
   copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
   SOFTWARE.
*/

import java.awt.*;
import javax.swing.*;
import java.util.*;

public class ContactListItem {
   public static final int STATUS_MESSAGE_RECEIVED = 0;
   public static final int STATUS_MESSAGE_READ = 1;
   public static final int STATUS_ONLINE  = 2;
   public static final int STATUS_OFFLINE = 3;
   
   private int id;
   private String nickName = null;
   private int status;
   private MessageWindow messageWindow;
   private ServerConnection sc;
   
   public ContactListItem(int cid, String nick, ServerConnection sc) {
      id = cid;
      nickName = nick;
      this.sc = sc;
      
      messageWindow = new MessageWindow(nick + " - Chat Session", sc, this);
      
      setStatus(STATUS_OFFLINE);
   }
   
   public void setStatus(int newStatus) {
      status = newStatus;
   }
   
   public int getStatus() {
      return status;
   }
   
   public int getID() {
      return id;
   }
   
   public String toString() {
      return nickName;
   }
   
   public String getStringForOrdering() {
      return String.valueOf(status) + nickName;
   }
   
   public void showMessageWindow() {
      messageWindow.show();
   }
   
   public void addMessage(String message) {
      messageWindow.addMessage(this.nickName + " wrote:\n" + message + "\n\n");
   }
}
