/* 
   IM Caf - A Java Based Instant Messaging System
   Author: Bruno Freitas - 08/2004
   Contact: bootsector@ig.com.br
 
   Copyright (c) 2004 Bruno Freitas

   Permission is hereby granted, free of charge, to any person obtaining a copy of
   this software and associated documentation files (the "Software"), to deal in 
   the Software without restriction, including without limitation the rights to 
   use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies 
   of the Software, and to permit persons to whom the Software is furnished to do 
   so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in all 
   copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
   SOFTWARE.
*/

import java.net.*;
import java.util.*;
import java.io.*;

public class ConnectionsList {
   private Vector ConnList;
   
   public ConnectionsList() {
      ConnList = new Vector();
   }
   
   public void addConnection(ConnectionItem conn) {
      ConnList.addElement(conn);
   }
   
   public ObjectInputStream getReader(String ip, int port) {
      Iterator it = ConnList.iterator();
      ObjectInputStream ois = null;
      ConnectionItem tmp = null;
      
      while(it.hasNext()) {
         tmp = (ConnectionItem) it.next();
         if ((ip.trim().compareToIgnoreCase(tmp.getSocket().getInetAddress().getHostAddress().trim())) == 0 && (tmp.getSocket().getPort() == port)) {
            ois = tmp.getReader();
            break;
         }
      }
      
      return ois;
   }
   
   public ObjectOutputStream getWriter(String ip, int port) {
      Iterator it = ConnList.iterator();
      ObjectOutputStream oos = null;
      ConnectionItem tmp = null;
      
      while(it.hasNext()) {
         tmp = (ConnectionItem) it.next();
         if ((ip.trim().compareToIgnoreCase(tmp.getSocket().getInetAddress().getHostAddress().trim())) == 0 && (tmp.getSocket().getPort() == port)) {
            oos = tmp.getWriter();
            break;
         }
      }
      
      return oos;
   }
   
   public Socket deleteConnection(String ip, int port) {
      Iterator it = ConnList.iterator();
      ConnectionItem tmp = null;
      Socket sock = null;
      
      while(it.hasNext()) {
         tmp = (ConnectionItem) it.next();
         if ((ip.trim().compareToIgnoreCase(tmp.getSocket().getInetAddress().getHostAddress().trim())) == 0 && (tmp.getSocket().getPort() == port)) {
            sock = tmp.getSocket();
            ConnList.remove(tmp);
            break;
         }
      }
      
      // Returns a reference to the removed socket. Null if socket was no found.
      return sock;
   }
   
   public Socket deleteConnection(ConnectionItem conn) {
      Iterator it = ConnList.iterator();
      ConnectionItem tmp = null;
      Socket sock = null;
      
      while(it.hasNext()) {
         tmp = (ConnectionItem) it.next();
         if (tmp == conn) {
            sock = tmp.getSocket();
            ConnList.remove(tmp);
            break;
         }
      }
      
      // Returns a reference to the removed socket. Null if socket was no found.
      return sock;
   }
}
